import org.springframework.context.support.*;
import uk.ac.ncl.cs.instantsoap.wsapi.*;
import static uk.ac.ncl.cs.instantsoap.wsapi.Wsapi.*;

public class NonblockedInvocationClient
{
    public static void main(String[] args)
            throws Throwable
    {
        ClassPathXmlApplicationContext context
                = new ClassPathXmlApplicationContext(new String[] {"client-beans.xml"});

        WebServiceDispatcher dispatcher = (WebServiceDispatcher) context.getBean("client");

        JobSpecification js = jobSpecification(
                "stringEcho",
                pair("messageIn", "Hi Mum!"));

// START SNIPPET: nonblocked-invocation
        NonBlockingInvocationResponse response = dispatcher.invokeNonBlocking(js);

        while(response.getJobStatus() == JobStatus.JobPending)
        {
            response.getUnit().sleep(response.getWait());
            response = dispatcher.pollForResult(response.getUuid());
        }

        System.out.println("The message was: "
                + response.getResults().get("messageOut"));
// END SNIPPET: nonblocked-invocation
    }
}

